package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class StrategyDef {
  protected StrategyName strategyname;
  public StrategyName get_strategyname() { return strategyname; }
  public void set_strategyname(StrategyName new_strategyname) { strategyname = new_strategyname; }
  protected StrategyExpression strategyexpression;
  public StrategyExpression get_strategyexpression() { return strategyexpression; }
  public void set_strategyexpression(StrategyExpression new_strategyexpression) { strategyexpression = new_strategyexpression; }
  public StrategyDef() { super(); }
  public StrategyDef(StrategyName strategyname, StrategyExpression strategyexpression) {
    super();
    set_strategyname(strategyname);
    set_strategyexpression(strategyexpression);
  }
  public static StrategyDef parse(java.io.Reader in) throws ParseException { return new Parser(in)._StrategyDef(); }
  public static StrategyDef parse(java.io.InputStream in) throws ParseException { return new Parser(in)._StrategyDef(); }
  public static StrategyDef parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_strategyname(this, strategyname);
    strategyname.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_strategyname(this, strategyname);
    ((UniversalVisitor) _v_).before_strategyexpression(this, strategyexpression);
    strategyexpression.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_strategyexpression(this, strategyexpression);
    universal_trv0_aft(_v_);
  }

}
